#include "skse/PluginAPI.h"
#include "skse/skse_version.h"
#include "skse/SafeWrite.h"
#include "skse/ScaleformCallbacks.h"
#include "skse/ScaleformMovie.h"
#include "skse/GameAPI.h"

// NativeFunctionX g߂ɕKvƂȂB
#include "skse/PapyrusNativeFunctions.h"

IDebugLog	gLog("skse_example_plugin.log");

PluginHandle	g_pluginHandle = kPluginHandle_Invalid;
SKSESerializationInterface	* g_serialization = NULL;
SKSEScaleformInterface		* g_scaleform = NULL;

/**** Papyrus֐ ****/

// ZaԂ
SInt32 Sum(StaticFunctionTag* self, SInt32 v1, SInt32 v2)
{
	return v1 + v2;
}

/**** scaleform functions ****/

bool RegisterScaleform(GFxMovieView * view, GFxValue * root)
{
	VMClassRegistry* registry = (*g_skyrimVM)->GetClassRegistry();

	// SamplePlugin.Add ֐o^
 	registry->RegisterFunction(
 		new NativeFunction2<StaticFunctionTag, SInt32, SInt32, SInt32>("Sum", "Calculator", Sum, registry));

	return true;
}



extern "C"
{


// SKSEĂяo֐B܂ŏɌĂяoB
// TESV.exẽo[WASKSET|[gĂC^tF[XȂǂmFB
// vOC̏ȂǂsȂĂ͂ȂB
// 
// 肪ȂtrueԂB
// falseԂƁASKSEdll̃CXg[𒆎~AJB
bool SKSEPlugin_Query(const SKSEInterface * skse, PluginInfo * info)
{
	_MESSAGE("skse_example_plugin");

	// Oݒ
	// vOC̖OAo[WZbg
	info->infoVersion =	PluginInfo::kInfoVersion;
	info->name =		"ExampleAddFunctionBySKSE Plugin";
	info->version =		1;

	// vOCnhۑ
	g_pluginHandle = skse->GetPluginHandle();

	if(skse->isEditor)
	{
		// CreationKitĂ΂ꂽꍇ(?)
		_MESSAGE("loaded in editor, marking as incompatible");

		return false;
	}
	else if(skse->runtimeVersion != RUNTIME_VERSION_1_9_32_0)
	{
		// TESV.exẽo[W1.9.32ȊO
		_MESSAGE("unsupported runtime version %08X", skse->runtimeVersion);

		return false;
	}

	// ScaleformC^tF[Xg邩ǂׂ
	g_scaleform = (SKSEScaleformInterface *)skse->QueryInterface(kInterface_Scaleform);
	if(!g_scaleform)
	{
		_MESSAGE("couldn't get scaleform interface");

		return false;
	}

	// ScaleformC^tF[X̃o[W𒲂ׂ
	if(g_scaleform->interfaceVersion < SKSEScaleformInterface::kInterfaceVersion)
	{
		_MESSAGE("scaleform interface too old (%d expected %d)", g_scaleform->interfaceVersion, SKSEScaleformInterface::kInterfaceVersion);

		return false;
	}

	// ### do not do anything else in this callback
	// ### only fill out PluginInfo and return true/false

	// supported runtime version
	return true;
}



// SKSEĂяo֐BSKSEPlugin_Query̎ɌĂяoB
// SKSEPlugin_QueryfalseԂꍇÅ֐͌Ă΂ȂB
// ̊֐ŃvOCB
//
// 肪ȂtrueԂB
// falseԂƁASKSEdll̃CXg[𒆎~AJB
bool SKSEPlugin_Load(const SKSEInterface * skse)
{
	_MESSAGE("load");

	// register scaleform callbacks
	// ScaleformR[obNo^Bo^ɐtrueԂB
	// o^Ɏgpς݂̏ꍇ͓o^sɂȂ̂ŁAj[NȖOœo^邱ƁB
	g_scaleform->Register("Calculator", RegisterScaleform);

	return true;
}

};
